unit dlgDirectory;

interface

uses
{$IFDEF WIN32}
  Windows, Messages, Graphics, Menus, Controls, Forms, ExtCtrls, ComCtrls, Dialogs, StdCtrls, Buttons,
{$ENDIF}

{$IFDEF LINUX}
  QGraphics, QMenus, QControls, QForms, QExtCtrls,  QComCtrls, QDialogs, QStdCtrls, QButtons,
{$ENDIF}

  SysUtils, Variants, Classes;

type
  TfrmSelectDir = class(TForm)
    Label1: TLabel;
    edtDirectory: TEdit;
    Button1: TButton;
    //UpDown1: TUpDown;
    edtDelay: TEdit;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FDir: string;
    FDelay: integer;
    { Private declarations }
  public
    { Public declarations }
  published
    property Directory : string read FDir;
    property Delay     : integer read FDelay;
  end;

var
  frmSelectDir: TfrmSelectDir;

implementation

{$IFDEF LINUX}
{$R *.xfm}
{$ENDIF}

{$IFDEF WIN32}
{$R *.dfm}
{$ENDIF}

{$IFDEF WIN32}
uses
  FileCtrl;
{$ENDIF}

procedure TfrmSelectDir.Button1Click(Sender: TObject);
var
{$IFDEF WIN32}
  dir : string;
{$ENDIF}
{$IFDEF LINUX}
  dir : WideString;
{$ENDIF}
begin
  // display a directory
  if SelectDirectory('Choose the directory containing the pictures','',Dir) then
  begin
    FDir := dir;
    edtDirectory.Text := FDir;
  end;
end;

procedure TfrmSelectDir.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := (ModalResult = mrCancel) or (edtDirectory.Text = '') or DirectoryExists(edtDirectory.Text);
  if (ModalResult = mrOk) then
   if (CanClose = false) then
    ShowMessage('Directory does not exist!')
   else
     FDir := edtDirectory.Text;

end;

procedure TfrmSelectDir.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
  FDelay := StrToInt(edtDelay.Text);
end;

end.
