program teststderr;
{$APPTYPE CONSOLE}
uses
{$IFDEF MSWINDOWS}
  Windows,
  SysUtils;
{$ENDIF}
{$IFDEF LINUX}
  Libc,
  SysUtils;
{$ENDIF}

var
  stderr : Textfile;

begin
  // Initially assign stderr to stdout
{$IFDEF LINUX}
  Assign( stderr, '');
{$ENDIF}
{$IFDEF MSWINDOWS}
  AssignFile( stderr, 'con' );
{$ENDIF}
  // open "stderr"
  Rewrite(stderr);

{$IFDEF MSWINDOWS}
  // now make the handle point to the stderr using the WinAPI call..
  TTextRec( stderr ).Handle := GetStdHandle( STD_ERROR_HANDLE );
{$ENDIF}
{$IFDEF LINUX}
  TTextRec( stderr ).Handle := Libc.stderr;
{$ENDIF}

  writeln(Output,'This will be printed on standard out!');
  writeln(stderr,'This will be printed on standard error!');
end.

